<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/
if (!defined("IN_FUSION") || !checkrights("I")) { header("Location: ../../index.php"); exit; }

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."ts_monitor/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."ts_monitor/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."ts_monitor/locale/English.php";
}

// Infusion general information
$inf_title = $locale['TSM100'];
$inf_description = $locale['TSM101'];
$inf_version = "1.0";
$inf_developer = "SirPsycho";
$inf_email = "sirpsycho@ev1.net";
$inf_weburl = "http://finesite.com";

$inf_folder = "ts_monitor"; // The folder in which the infusion resides.
$inf_admin_image = "/images/ts_monitor.jpg"; // Leave blank to use the default image.
$inf_admin_panel = "ts_monitor_admin.php"; // The admin panel filename if required.

$inf_link_name = $locale['tsm102']; // if not required replace $locale['xxx102']; with "";
$inf_link_url = ""; // The filename you wish to link to.
$inf_link_visibility = "101"; // 0 - Guest / 101 - Member / 102 - Admin / 103 - Super Admin.

$inf_newtables = 1; // Number of new db tables to create or drop.
$inf_insertdbrows = 2; // Numbers rows added into created db tables.
$inf_altertables = 0; // Number of db tables to alter (upgrade).
$inf_deldbrows = 1; // Number of db tables to delete data from.

// Delete any items not required here.
$inf_newtable_[1] = "ts_monitor (
		server_id smallint(5) unsigned NOT NULL auto_increment,
		serverAddress text NOT NULL,
		serverName text NOT NULL,
		serverQueryPort int(10) unsigned NOT NULL default '51234',
		serverUDPPort int(10) unsigned NOT NULL default '8767',
		show_empty smallint(5) unsigned NOT NULL default '1',
		PRIMARY KEY  (server_id)
		) TYPE=MyISAM;";

$inf_insertdbrow_[1] = "panels` VALUES ('', 'TS Monitor', 'ts_monitor', '', 3, 6, 'file', 0, 0);";
$inf_insertdbrow_[2] = "ts_monitor` VALUES ('', '00.00.00.000', 'My TS Server', '51234', '8767', '0');";

$inf_droptable_[1] = "ts_monitor";

$inf_altertable_[1] = "";

$inf_deldbrow_[1] = "panels` WHERE panel_name='TS Monitor'";

?>