<?

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."ts_monitor/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."ts_monitor/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."ts_monitor/locale/English.php";
}

//Get Server Vars
	$result = dbquery("SELECT * FROM ".DB_PREFIX."ts_monitor LIMIT 1");
		while ($data = dbarray($result)) {
			$server_id = $data['server_id'];
			$serverAddress = $data['serverAddress'];
			$serverName = $data['serverName'];
			$serverQueryPort = $data['serverQueryPort'];
			$serverUDPPort = $data['serverUDPPort'];
			$show_empty = $data['show_empty'];
			$count++;
		}	
	$result = dbquery("SELECT * FROM ".DB_PREFIX."panels WHERE panel_filename = 'ts_monitor'");
		while ($data = dbarray($result)) {
			$ts_status = $data['panel_status'];
			$count++;
		}

// Sets the states on check boxes for settings pages.
function StatusChecked($val) {
	if ($val == 1){
	return "checked";
	}
}

// opens a connection to the teamspeak server
function getSocket($host, $port, $errno, $errstr, $timeout) {
global $errno, $errstr;
	@$socket = fsockopen($host, $port, $errno, $errstr, $timeout);
		if($socket and fread($socket, 4) == "[TS]") {
			fgets($socket, 128);
			return $socket;
		}// end if
	return false;
}// end function getSocket(...)


// sends a query to the teamspeak server
function sendQuery($socket, $query) {
	fputs($socket, $query."\n");
}


// answer OK?
function getOK($socket) {
	$result = fread($socket, 2);
	fgets($socket, 128);
	return($result == "OK");
}


// closes the connection to the teamspeak server
function closeSocket($socket) {
	fputs($socket, "quit");
	fclose($socket);
}


// retrieves the next argument in a tabulator-separated string (PHP scanf function bug workaround)
function getNext($evalString) {
	$pos = strpos($evalString, "\t");
	if(is_integer($pos)) {
		return substr($evalString, 0, $pos);
	} else {
		return $evalString;
	}
}


// removes the first argument in a tabulator-separated string (PHP scanf function bug workaround)
function chopNext($evalString) {
	$pos = strpos($evalString, "\t");
	if(is_integer($pos)) {
		return substr($evalString, $pos + 1);
	} else {
	return "";
	}
}


// retrieve player list
function GetPlayers($socket) {
sendQuery($socket,"pl");
$playerList = array();
do 
  {
  $playerinfo = "";
  do 
    {
    $input = fread($socket, 1);
    if($input != "\n" && $input != "\r") $playerinfo .= $input;
    } while($input != "\n");

  $playerid = getNext($playerinfo);
    $playerinfo = chopNext($playerinfo);
  $channelid = getNext($playerinfo);
    $playerinfo = chopNext($playerinfo);
  $sentpackets = getNext($playerinfo);
    $playerinfo = chopNext($playerinfo);
  $sentbytes = getNext($playerinfo);
    $playerinfo = chopNext($playerinfo);
  $receivedpackets = getNext($playerinfo);
    $playerinfo = chopNext($playerinfo);
  $receivedbytes = getNext($playerinfo);
    $playerinfo = chopNext($playerinfo);
  $d = getNext($playerinfo);
    $playerinfo = chopNext($playerinfo);
  $d = getNext($playerinfo);
    $playerinfo = chopNext($playerinfo);
  $totaltime = getNext($playerinfo);
    $playerinfo = chopNext($playerinfo);
  $idletime = getNext($playerinfo);
    $playerinfo = chopNext($playerinfo);
  $cprivs = getNext($playerinfo);
    $playerinfo = chopNext($playerinfo);
  $pprivs = getNext($playerinfo);
    $playerinfo = chopNext($playerinfo);
  $pflags = getNext($playerinfo);
    $playerinfo = chopNext($playerinfo);
  $pip = getNext($playerinfo);
    $playerinfo = chopNext($playerinfo);
  $playername = getNext($playerinfo);
    $playerinfo = chopNext($playerinfo);
  $s = getNext($playerinfo);

  //Strip the quotes (") off both ends of the player name
  if ( $playername != "" )
    {
    $playername = substr( $playername , 1 , strlen($playername)-2 );
    }

// Strip out lines of data not intended for player array
  if($playerid != "OK" && $playerid != "p_id") 
    {
    $playerList[$playerid] = array(
    "playerid" => $playerid,
    "channelid" => $channelid,
    "receivedpackets" => $receivedpackets,
    "receivedbytes" => $receivedbytes,
    "sentpackets" => $sentpackets,
    "sentbytes" => $sentbytes,
    "totaltime" => $totaltime,
    "idletime" => $idletime,
    "cprivs" => $cprivs,
    "pprivs" => $pprivs,
    "pflags" => $pflags,
	"pip" => $pip,
    "playername" => $playername);
    }
  } while($playerid != "OK");
	return $playerList;
} // End player list function


function GetChannels($socket) {
sendQuery($socket,"cl");

$channelList = array();
do {
	$channelinfo = "";
	do {
		$input = fread($socket, 1);
		if($input != "\n" && $input != "\r") $channelinfo .= $input;
	} while($input != "\n");
	$channelid = getNext($channelinfo);
		$channelinfo = chopNext($channelinfo);
	$codec = getNext($channelinfo);
		$channelinfo = chopNext($channelinfo);
	$parent = getNext($channelinfo);
		$channelinfo = chopNext($channelinfo);
	$order = getNext($channelinfo);
		$channelinfo = chopNext($channelinfo);
	$maxplayers = getNext($channelinfo);
		$channelinfo = chopNext($channelinfo);
	$channelname = getNext($channelinfo);
		$channelinfo = chopNext($channelinfo);
	$cflags = getNext($channelinfo);
		$channelinfo = chopNext($channelinfo);
	$d = getNext($channelinfo);
		$channelinfo = chopNext($channelinfo);
	$topic = getNext($channelinfo);
	
  if ( $channelname != "" && $channelname != 'name' )
    {
    $channelname = substr( $channelname , 1 , strlen($channelname)-2 );
    }

// Keep header and OK notice out of array.
	if($channelid != "OK" && $channelname != "name") {
		if($isdefault == "Default") $isdefault = 1; else $isdefault = 0;

		$channelList[$channelid] = array("channelid" => $channelid,
			"codec" => $codec,
			"parent" => $parent,
			"maxplayers" => $maxplayers,
			"channelname" => $channelname,
			"cflags" => $cflags,
			"isdefault" => $isdefault,
			"topic" => $topic,
			"currentplayers" => $playercount);
	}
} while($channelid != "OK");
return $channelList;
} //End channel list function


// Thanks to Radley Smith for this function
// Not Implemented yet.
function multisort(&$array, $sortby, $order='asc') {
   foreach($array as $val) {
       $sortarray[] = $val[$sortby];
   }
   $c = $array;
   $const = $order == 'asc' ? SORT_ASC : SORT_DESC;
   $s = array_multisort($sortarray, $const, $useless, $const);
   $array = $c;
   return $s;
}

function ChannelFlags($cflag) {
if ( $cflag != 0 )
      {
      $clabel .= "(";
      if ( $cflag & 1 ) $clabel .= "U";
      else              $clabel .= "R";
      if ( $cflag & 2 ) $clabel .= "M";
      if ( $cflag & 4 ) $clabel .= "P";
      if ( $cflag & 8 ) $clabel .= "S";
      if ( $cflag & 16) $clabel .= "D";
      $clabel .= ")";
      }
	return $clabel;
}

function PlayerFlags($playerInfo) {

	// Build up player info from flags
	$plabel = "(";
	if ( $playerInfo[pprivs] & 4 ) $plabel .= "R";
	else                           $plabel .= "U";
	if ( $playerInfo[pprivs] & 1 ) $plabel .= " SA";
	if ( $playerInfo[cprivs] & 1 ) $plabel .= " CA";
	if ( $playerInfo[cprivs] & 8 ) $plabel .= " AO";
	if ( $playerInfo[cprivs] & 16) $plabel .= " AV";
	if ( $playerInfo[cprivs] & 2 ) $plabel .= " O";
	if ( $playerInfo[cprivs] & 4 ) $plabel .= " V";
	$plabel .= ")";

return $plabel;

}

// Builds array for setting the appropriate status icon and ALT text for players.
function PlayerImage($playerInfo) {
	if ($playerInfo[pflags] & 8 ) {
		$pgraphic = "away";
		$pAltText = TS_AWAY;
		}
	elseif ($playerInfo[pflags] & 32) {
		$pgraphic = "mute";
		$pAltText = TS_MUTE;
		}
	elseif ($playerInfo[pflags] & 16) {
		$pgraphic = "mmic";
		$pAltText = TS_MIC_MUTE;
		}
	else
	  {
	  if ($playerInfo[pflags] & 1 ) {
	  	$pgraphic = "cc_";
		$pAltText = TS_CHANNELCOMMANDER;
		}
	  else {
	  	$pgraphic = ""; 
		$pAltText = ""; 
	  }
	  if ($playerInfo[idletime] <= 5 ) {
	  	$pgraphic .= "talk";
		$pAltText = TS_TALKING;
	  	}
	  else {
	  	$pgraphic .= "player"; 
	  	$pAltText = TS_PLAYER;
	  }
	}
	$pStatus = array("image" => "ts_$pgraphic.gif", "AltText" => $pAltText );
return $pStatus;

}

?>